CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

OBJ

  re    : "regex"
  io    : "FullDuplexSerial"

PUB  Start | teststr, pattern, resaddr, rslt, i

  io.start(31, 30, 0, 9600)
  io.tx(0)
  
  teststr := string("$GPGSV,2,1,08,01,40,083,46,02,17,308,41,12,07,344,39,14,22,228,45*75", 13, {
                 }  "$GPRMC,123519,A,4807.038,N,01131.000,E,022.4,084.4,230394,003.1,W*6A", 13, {
                 }  "$GPVTG,054.7,T,034.4,M,005.5,N,010.2,K*48", 13)
                 
  pattern := string("\$GPRMC\s*,[^,]*,[^,]*,($1[\d\.]+)\s*,($2N|S)\s*,($3[\d\.]+)\s*,($4E|W)")

  io.str(string("String:", 13, 13))
  io.str(teststr)
  io.str(string(13, 13, "Pattern:", 13, 13))
  io.str(pattern)

  rslt := -cnt
  resaddr := re.match(teststr, pattern, re#NOALT)
  rslt += cnt

  io.str(string(13, 13, "Time: "))
  io.dec(rslt / 80_000)
  io.str(string(" ms."))
  io.str(string(13, 13, "Results:", 13))

  if (resaddr < 0)
    io.tx(13)
    io.str(string("Error #"))
    io.dec(-resaddr)
  elseif (resaddr == 0)
    io.tx(13)
    io.str(string("No match."))
  else
    repeat i from 0 to 9
      if (rslt := long[resaddr][i])
        io.tx(13)
        io.dec(i)
        io.str(string(": "))
        io.str(re.field(i))

    io.str(string(13, 13, "Remainder of string:", 13, 13))
    io.str(re.remainder)
     